#include <malloc.h>
#include "qsort_file.h"

// Texte zu den Fehlercodes
const char *fehlertexte[] =
{
	/* 0 */ "OK",
	/* 1 */ "Quelldatei kann nicht zum Lesen geoeffnet werden",
	/* 2 */ "Zieldatei kann nicht angelegt werden",
	/* 3 */ "Fehler beim Lesen der Quelldatei",
	/* 4 */ "Nicht genuegend Speicher",
	/* 5 */ "Ungueltige Zahl der Adressangaben",
	/* 6 */ "Zahl der Argumente in der Kommandozeile falsch",
	/* 7 */ "Ungueltige Adresse"
};


void aufraeumen(void)
{
	// Offene Dateien schliessen
	if (verwaltung.src) fclose(verwaltung.src);
	if (verwaltung.dst) fclose(verwaltung.dst);

	// Speicher zurckgeben, falls noch belegt
	if (kundendaten.dis) free(kundendaten.dis);
	if (kundendaten.adr) free(kundendaten.adr);

	// Fehlermeldung ausgeben, falls Fehler gemeldet
	if ((verwaltung.fehlernummer > 0) && (verwaltung.fehlernummer <= sizeof(fehlertexte) / sizeof(char*)))
	{
		printf("\n\nFehlercode %d: %s\n\n", verwaltung.fehlernummer, fehlertexte[verwaltung.fehlernummer]);
		fflush(stdout);
	}
}


// Ausgabe einer Adresse in die Datei dst
bool	print_address(FILE *dst, ADRUNION_T *a)
{
	int i;

	// Gltiges Ziel fr den Druck angegeben?
	if (dst == NULL) return false;

	// Ist ein gltiger Zeiger bergeben worden?
	if (a == NULL) return false;

	// Sind die Zeiger auf die einzelnen Strings gltig?
	for (i = 0; i < SPALTEN; i++)
	{
		if (a->fg[i] == NULL) return false;
	}
	// Ausgabe an das angegebene Ziel
	fprintf(dst, "%s, %s\n%s %s\n\n", a->fi.name, a->fi.vorname, a->fi.plz, a->fi.ort);

	return true;
}