#pragma once

#include <stdio.h>
#include <stdbool.h>

// Anzahl der Elemente fr einen Adresseintrag
#define SPALTEN 4

// Definition einer Struktur mit Namen fr die Elemente
typedef struct
{
	char *name;
	char *vorname;
	char *plz;
	char *ort;
} ADR_NAME_T;

// Union aus benannten Elementen (fi) und einem Feld (fg) als Alternative
typedef union
{
	char		*fg[SPALTEN];
	ADR_NAME_T  fi;
} ADRUNION_T;

// Definition einer Struktur fr die Datenbank im Speicher
typedef struct
{
	int			flen;	// Lnge der Quelldatei (binr)
	char		*dis;	// Beginn der Daten im Speicher
	int			num;	// Anzahl der Adresselemente (Typ ADRUNION_T)
	ADRUNION_T	*adr;	//Beginn des Sortierfelds (fr qsort)
} KDB_T;

// Struktur fr die Gesamtverwaltung
typedef struct
{
	FILE *src;			// Handle auf die Quelldatei
	FILE *dst;			// HAndle auf die Zieldatei
	int fehlernummer;	// Fehlercode (zuletzt erkannter Fehler)
} VERWALTUNG_T;

// Deklaration der globalen Variablen
extern VERWALTUNG_T verwaltung;
extern KDB_T kundendaten;

// Funktionsdeklarationen
int		vergleiche_adresse(const void *a, const void *b);
bool	quelle_lesen(VERWALTUNG_T *vw, KDB_T *db);
bool	daten_vorbereiten(VERWALTUNG_T *vw, KDB_T *db);
void	aufraeumen(void);
bool	print_address(FILE *dst, ADRUNION_T *a);
int		main(int argnum, char *argumente[]);

